
#ifndef RWSIM_MOTIONISOSMALLANGLE_H
#define RWSIM_MOTIONISOSMALLANGLE_H

#include "base.h"
#include "coordinates.h"

class SmallAngle final : public Motion {
public:
    SmallAngle(double, double, double, std::mt19937_64& );
    explicit SmallAngle(std::mt19937_64&);

    void initialize() override;
    double jump() override;
    void setParameters(const std::unordered_map<std::string, double> &) override;
    [[nodiscard]] std::unordered_map<std::string, double> getParameters() const override;
    [[nodiscard]] std::string toString() const override;

private:
    double m_chi{0};
    SphericalPos m_prev_pos{0., 0.};
};

#endif //RWSIM_MOTIONISOSMALLANGLE_H
